
Ruby - Bug #9063

irb crashes when #backtrace of raised Exception is nil

10/31/2013 01:05 AM - makimoto (Shimpei Makimoto)

Status: Closed   

Priority: Normal   

Assignee: keiju (Keiju Ishitsuka)   

Target version:    

ruby -v: ruby 2.1.0dev (2013-10-30 trunk 43474)

[x86_64-darwin13.0.0]

Backport: 1.9.3: UNKNOWN, 2.0.0: UNKNOWN

Description

=begin

See also the pull req on GitHub: https://github.com/ruby/ruby/pull/434

When an exception whose backtrace is nil is raised, irb crashes and exits with the following backtrace:

irb> class E < Exception; def backtrace; nil; end; end

irb> raise E

E: E

/Users/makimoto/.rbenv/versions/trunk/lib/ruby/2.1.0/irb.rb:502:in block (2 levels) in eval_input': undefined method []' for nil:NilClass

(NoMethodError)

from /Users/makimoto/.rbenv/versions/trunk/lib/ruby/2.1.0/irb.rb:624:in signal_status' from

/Users/makimoto/.rbenv/versions/trunk/lib/ruby/2.1.0/irb.rb:489:in block in eval_input'

from /Users/makimoto/.rbenv/versions/trunk/lib/ruby/2.1.0/irb/ruby-lex.rb:247:in block (2 levels) in each_top_level_statement' from

/Users/makimoto/.rbenv/versions/trunk/lib/ruby/2.1.0/irb/ruby-lex.rb:233:in loop'

from /Users/makimoto/.rbenv/versions/trunk/lib/ruby/2.1.0/irb/ruby-lex.rb:233:in block in each_top_level_statement' from

/Users/makimoto/.rbenv/versions/trunk/lib/ruby/2.1.0/irb/ruby-lex.rb:232:in catch'

from /Users/makimoto/.rbenv/versions/trunk/lib/ruby/2.1.0/irb/ruby-lex.rb:232:in each_top_level_statement' from

/Users/makimoto/.rbenv/versions/trunk/lib/ruby/2.1.0/irb.rb:488:in eval_input'

from /Users/makimoto/.rbenv/versions/trunk/lib/ruby/2.1.0/irb.rb:397:in block in start' from

/Users/makimoto/.rbenv/versions/trunk/lib/ruby/2.1.0/irb.rb:396:in catch'

from /Users/makimoto/.rbenv/versions/trunk/lib/ruby/2.1.0/irb.rb:396:in start' from /Users/makimoto/.rbenv/versions/trunk/bin/irb:11:in '

=end

Associated revisions

Revision f741fd2d9d55afb535c3fd5635b2ee5252bedb68 - 08/13/2014 02:19 AM - hsbt (Hiroshi SHIBATA)

lib/irb.rb: Prevent irb from crashing when exception with

nil backtrace is raised.

[fix GH-434][ruby-core:58078][Bug #9063]

test/irb/test_raise_no_backtrace_exception.rb: ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@47164 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision f741fd2d - 08/13/2014 02:19 AM - hsbt (Hiroshi SHIBATA)

lib/irb.rb: Prevent irb from crashing when exception with

nil backtrace is raised.

[fix GH-434][ruby-core:58078][Bug #9063]

test/irb/test_raise_no_backtrace_exception.rb: ditto.

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@47164 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 10/31/2013 01:37 AM - sorah (Sorah Fukumori)

- Status changed from Open to Assigned

- Assignee set to keiju (Keiju Ishitsuka)

+1, I think irb shouldn't die even if caught Exception is something wrong.
https://github.com/ruby/ruby/pull/434


Could you attach a patch for here too?

#2 - 10/31/2013 07:27 AM - makimoto (Shimpei Makimoto)

- File irb-when-backtrace-nil.patch added

attached a patch. (which is same with https://github.com/ruby/ruby/pull/434.patch )

#3 - 11/27/2013 02:46 PM - sorah (Sorah Fukumori)

ping?

#4 - 08/13/2014 02:19 AM - hsbt (Hiroshi SHIBATA)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

Applied in changeset r47164.

lib/irb.rb: Prevent irb from crashing when exception with

nil backtrace is raised.

[fix GH-434][ruby-core:58078][Bug #9063]

test/irb/test_raise_no_backtrace_exception.rb: ditto.

Files

irb-when-backtrace-nil.patch 2.91 KB 10/31/2013 makimoto (Shimpei Makimoto)
